/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.139 Revision 1.155
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.139 2011/10/15 20:58:08 phajdan.jr Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.155 2012/06/09 10:01:19 marienz Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
13if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 14 inherit multilib
15fi
16
17# Export pkg_setup every time to avoid issues with eclass inheritance order.
18if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
19 EXPORT_FUNCTIONS pkg_setup
20fi
21
22# Avoid processing this eclass more than once.
23if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
24_PYTHON_ECLASS_INHERITED="1"
13 25
14if ! has "${EAPI:-0}" 0 1 2 3 4; then 26if ! has "${EAPI:-0}" 0 1 2 3 4; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 27 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 28fi
17 29
18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 30_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2) 31_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython) 32_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
21_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.5) 33_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8 2.7-pypy-1.9)
22_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]}) 34_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
23 35
24# ================================================================================================ 36# ================================================================================================
25# ===================================== HANDLING OF METADATA ===================================== 37# ===================================== HANDLING OF METADATA =====================================
26# ================================================================================================ 38# ================================================================================================
86 98
87 return 1 99 return 1
88 fi 100 fi
89} 101}
90 102
103_python_implementation() {
104 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
105 return 0
106 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
107 return 0
108 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
109 return 0
110 else
111 return 1
112 fi
113}
114
91_python_package_supporting_installation_for_multiple_python_abis() { 115_python_package_supporting_installation_for_multiple_python_abis() {
92 if has "${EAPI:-0}" 0 1 2 3 4; then 116 if has "${EAPI:-0}" 0 1 2 3 4; then
93 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 117 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
94 return 0 118 return 0
95 else 119 else
231 else 255 else
232 die "Invalid syntax of PYTHON_DEPEND" 256 die "Invalid syntax of PYTHON_DEPEND"
233 fi 257 fi
234} 258}
235 259
260if _python_implementation; then
236DEPEND=">=app-admin/eselect-python-20091230" 261 DEPEND=">=app-admin/eselect-python-20091230"
237RDEPEND="${DEPEND}" 262 RDEPEND="${DEPEND}"
263 PDEPEND="app-admin/python-updater"
264fi
238 265
239if [[ -n "${PYTHON_DEPEND}" ]]; then 266if [[ -n "${PYTHON_DEPEND}" ]]; then
240 _python_parse_PYTHON_DEPEND 267 _python_parse_PYTHON_DEPEND
241else 268else
242 _PYTHON_ATOMS=("dev-lang/python") 269 _PYTHON_ATOMS=("dev-lang/python")
281 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" 308 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
282 fi 309 fi
283 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then 310 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
284 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )" 311 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
285 fi 312 fi
286 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 313 DEPEND+="${DEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
287 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 314 RDEPEND+="${RDEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
288 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY 315 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
289fi 316fi
290 317
291unset _PYTHON_ATOMS 318unset _PYTHON_ATOMS
292 319
293# ================================================================================================ 320# ================================================================================================
294# =================================== MISCELLANEOUS FUNCTIONS ==================================== 321# =================================== MISCELLANEOUS FUNCTIONS ====================================
295# ================================================================================================ 322# ================================================================================================
296
297_python_implementation() {
298 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
299 return 0
300 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
301 return 0
302 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
303 return 0
304 else
305 return 1
306 fi
307}
308 323
309_python_abi-specific_local_scope() { 324_python_abi-specific_local_scope() {
310 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]] 325 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
311} 326}
312 327
384 _CYAN= 399 _CYAN=
385 _NORMAL= 400 _NORMAL=
386 fi 401 fi
387} 402}
388 403
389unset PYTHON_PKG_SETUP_EXECUTED
390
391_python_check_python_pkg_setup_execution() { 404_python_check_python_pkg_setup_execution() {
392 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return 405 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
393 406
394 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then 407 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
395 die "python_pkg_setup() not called" 408 die "python_pkg_setup() not called"
463 fi 476 fi
464 477
465 PYTHON_PKG_SETUP_EXECUTED="1" 478 PYTHON_PKG_SETUP_EXECUTED="1"
466} 479}
467 480
468if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
469 EXPORT_FUNCTIONS pkg_setup
470fi
471
472_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)' 481_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
473 482
474# @FUNCTION: python_convert_shebangs 483# @FUNCTION: python_convert_shebangs
475# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories] 484# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
476# @DESCRIPTION: 485# @DESCRIPTION:
477# Convert shebangs in specified files. Directories can be specified only with --recursive option. 486# Convert shebangs in specified files. Directories can be specified only with --recursive option.
478python_convert_shebangs() { 487python_convert_shebangs() {
479 _python_check_python_pkg_setup_execution 488 _python_check_python_pkg_setup_execution
480 489
481 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" 490 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
482 491
483 while (($#)); do 492 while (($#)); do
484 case "$1" in 493 case "$1" in
485 -r|--recursive) 494 -r|--recursive)
486 recursive="1" 495 recursive="1"
541 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 550 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
542 551
543 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then 552 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
544 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 553 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
545 554
555 shebangs_converted="1"
556
546 if [[ "${quiet}" == "0" ]]; then 557 if [[ "${quiet}" == "0" ]]; then
547 einfo "Converting shebang in '${file}'" 558 einfo "Converting shebang in '${file}'"
548 fi 559 fi
549 560
550 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed" 561 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
551 fi 562 fi
563 done
564
565 if [[ "${shebangs_converted}" == "0" ]]; then
566 ewarn "${FUNCNAME}(): Python scripts not found"
567 fi
568}
569
570# @FUNCTION: python_clean_py-compile_files
571# @USAGE: [-q|--quiet]
572# @DESCRIPTION:
573# Clean py-compile files to disable byte-compilation.
574python_clean_py-compile_files() {
575 _python_check_python_pkg_setup_execution
576
577 local file files=() quiet="0"
578
579 while (($#)); do
580 case "$1" in
581 -q|--quiet)
582 quiet="1"
583 ;;
584 -*)
585 die "${FUNCNAME}(): Unrecognized option '$1'"
586 ;;
587 *)
588 die "${FUNCNAME}(): Invalid usage"
589 ;;
590 esac
591 shift
592 done
593
594 while read -d $'\0' -r file; do
595 files+=("${file#./}")
596 done < <(find -name py-compile -type f -print0)
597
598 for file in "${files[@]}"; do
599 if [[ "${quiet}" == "0" ]]; then
600 einfo "Cleaning '${file}' file"
601 fi
602 echo "#!/bin/sh" > "${file}"
552 done 603 done
553} 604}
554 605
555# @FUNCTION: python_clean_installation_image 606# @FUNCTION: python_clean_installation_image
556# @USAGE: [-q|--quiet] 607# @USAGE: [-q|--quiet]
794 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}" 845 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
795 fi 846 fi
796 else 847 else
797 python3_version="" 848 python3_version=""
798 fi 849 fi
850 fi
851
852 if [[ -z "${python2_version}" && -z "${python3_version}" ]]; then
853 eerror "${CATEGORY}/${PF} requires at least one of the following packages:"
854 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
855 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
856 eerror " dev-lang/python:${PYTHON_ABI}"
857 fi
858 done
859 die "No supported version of CPython installed"
799 fi 860 fi
800 861
801 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then 862 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
802 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink" 863 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
803 eerror "is set incorrectly. Use \`eselect python\` to fix configuration." 864 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
961 python_default_function() { 1022 python_default_function() {
962 emake "$@" 1023 emake "$@"
963 } 1024 }
964 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 1025 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
965 python_default_function() { 1026 python_default_function() {
1027 # Stolen from portage's _eapi0_src_test()
1028 local emake_cmd="${MAKE:-make} ${MAKEOPTS} ${EXTRA_EMAKE}"
966 if emake -j1 -n check &> /dev/null; then 1029 if ${emake_cmd} -j1 -n check &> /dev/null; then
967 emake -j1 check "$@" 1030 ${emake_cmd} -j1 check "$@"
968 elif emake -j1 -n test &> /dev/null; then 1031 elif ${emake_cmd} -j1 -n test &> /dev/null; then
969 emake -j1 test "$@" 1032 ${emake_cmd} -j1 test "$@"
970 fi 1033 fi
971 } 1034 }
972 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 1035 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
973 python_default_function() { 1036 python_default_function() {
974 emake DESTDIR="${D}" install "$@" 1037 emake DESTDIR="${D}" install "$@"
1242cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)") 1305cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1243python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)") 1306python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1244python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1307python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1245 1308
1246pypy_versions_mapping = { 1309pypy_versions_mapping = {
1247 "1.5": "2.7" 1310 "1.5": "2.7",
1311 "1.6": "2.7",
1312 "1.7": "2.7",
1313 "1.8": "2.7",
1314 "1.9": "2.7",
1248} 1315}
1249 1316
1250def get_PYTHON_ABI(python_interpreter): 1317def get_PYTHON_ABI(python_interpreter):
1251 cpython_matched = cpython_interpreter_re.match(python_interpreter) 1318 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1252 jython_matched = jython_interpreter_re.match(python_interpreter) 1319 jython_matched = jython_interpreter_re.match(python_interpreter)
1592 fi 1659 fi
1593 done 1660 done
1594 1661
1595 popd > /dev/null || die "popd failed" 1662 popd > /dev/null || die "popd failed"
1596 1663
1664 # This is per bug #390691, without the duplication refactor, and with
1665 # the 3-way structure per comment #6. This enable users with old
1666 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1667 # before coreutils can be upgraded).
1597 if ROOT="/" has_version sys-apps/coreutils; then 1668 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1598 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1669 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1670 elif ROOT="/" has_version sys-apps/coreutils; then
1671 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1599 else 1672 else
1600 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1673 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1601 fi 1674 fi
1602 done 1675 done
1603 1676
3108} 3181}
3109 3182
3110# ================================================================================================ 3183# ================================================================================================
3111# ===================================== DEPRECATED FUNCTIONS ===================================== 3184# ===================================== DEPRECATED FUNCTIONS =====================================
3112# ================================================================================================ 3185# ================================================================================================
3186
3187fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.139  
changed lines
  Added in v.1.155

  ViewVC Help
Powered by ViewVC 1.1.20